﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using Fasterflect;
using System.Reflection;

namespace QuickTrimPerformance
{
	public static class QuickTrim_FasterFlect2
	{
		private static IDictionary<PropertyInfo, MemberGetter> getters = new Dictionary<PropertyInfo, MemberGetter>();
		private static IDictionary<PropertyInfo, MemberSetter> setters = new Dictionary<PropertyInfo, MemberSetter>();

		public static void NullSafeTrimStrings_FasterFlect2<T>(this T item)
		{
			Type itemType = typeof(T);

			var props = PropertyCache.Instance.GetProperties(itemType);

			foreach (var prop in props)
			{
				if(!getters.ContainsKey(prop))
					getters[prop] = itemType.DelegateForGetPropertyValue(prop.Name);
				
				if(!setters.ContainsKey(prop))
					setters[prop] = itemType.DelegateForSetPropertyValue(prop.Name);

				string currentValue = (string)getters[prop](item);
				setters[prop](item, currentValue.NullSafeTrim());
			}
		}
	}
}
