﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace QuickTrimPerformance
{
	public class Testing
	{
		public const int NumberOfTimes = 1000 * 1000; 

		public static TestModel GetModel(int i)
		{
			return new TestModel()
			{
				Title = "Quickly trimmig " + i + " the fat from models  ",
				BodyText = "   try out some of  " + i + "the sample code which can be downloaded here ",
				Date = DateTime.UtcNow,
				Tags = new string[] { "MVC", ".NET", "REFLECTION" },
				Unique = Guid.NewGuid(),
				Id = i
			};
		}

		[Benchmark]
		public static void LongHandTrim()
		{

			for (int i = 0; i < NumberOfTimes; i++)
			{
				var blog = GetModel(i);
				blog.NullSafeTrimStrings_LongHand();
			}
		}

		[Benchmark]
		public static void InitialTrim()
		{
			
			for (int i = 0; i < NumberOfTimes; i++)
			{
				var blog = GetModel(i);
				blog.NullSafeTrimStrings_Initial();
			}
		}

		[Benchmark]
		public static void Trim_FasterFlect()
		{
			
			for (int i = 0; i < NumberOfTimes; i++)
			{
				var blog = GetModel(i);
				blog.NullSafeTrimStrings_FasterFlect();
			}
		}

		[Benchmark]
		public static void Trim_FasterFlect2()
		{
			for (int i = 0; i < NumberOfTimes; i++)
			{
				var blog = GetModel(i);
				blog.NullSafeTrimStrings_FasterFlect2();
			}
		}
	}
}
